

// #include <stdio.h>
// #include <string.h>
// #include <zephyr/kernel.h>
// #include <zephyr/net/socket.h>
// #include <zephyr/logging/log.h>
// #include <dk_buttons_and_leds.h>
// #include <modem/nrf_modem_lib.h>
// #include <modem/lte_lc.h>
// #include <zephyr/net/mqtt.h>
// #include "mqtt_connection.h"
// #include <zephyr/device.h>
// #include <zephyr/devicetree.h>
// #include <zephyr/drivers/gpio.h>
// #include <zephyr/sys/printk.h>
// #include <zephyr/logging/log.h>
// #include <zephyr/drivers/uart.h>

// // UART2 
// #define SLEEP_TIME_MS   1000
// #define RECEIVE_BUFF_SIZE 70
// #define RECEIVE_TIMEOUT 1000  // usec  around 10 usec for each bit that is transmitted 

// const struct device *uart= DEVICE_DT_GET(DT_NODELABEL(uart2));
// static uint8_t rx_buf[RECEIVE_BUFF_SIZE] = {0};
// static uint8_t temp[RECEIVE_BUFF_SIZE] = {0};

// static struct mqtt_client client;
// static struct pollfd fds;
// static K_SEM_DEFINE(lte_connected, 0, 1);

// LOG_MODULE_REGISTER(LTE, LOG_LEVEL_DBG);

// // flag to indicate the transmission of data
// bool flag1 = 0;

// static void uart_cb(const struct device *dev, struct uart_event *evt, void *user_data)
// {
// 	switch (evt->type) {

// 	case UART_RX_RDY:

// 		flag1 = 1;
// 		printk("D_len: %d\n\r",evt->data.rx.len); 										// for debugging 
// 		memcpy(temp, &evt->data.rx.buf[evt->data.rx.offset], 70); 
		

// 	break;
// 	case UART_RX_DISABLED:

// 		uart_rx_enable(dev ,rx_buf,sizeof rx_buf,RECEIVE_TIMEOUT);
// 		break;
		
// 	default:
// 		break;
// 	}
// }



// static void lte_handler(const struct lte_lc_evt *const evt)
// {
//      switch (evt->type) {
//      case LTE_LC_EVT_NW_REG_STATUS:
//         if ((evt->nw_reg_status != LTE_LC_NW_REG_REGISTERED_HOME) &&
//             (evt->nw_reg_status != LTE_LC_NW_REG_REGISTERED_ROAMING)) {
//             break;
//         }
// 		LOG_INF("Network registration status: %s",
// 				evt->nw_reg_status == LTE_LC_NW_REG_REGISTERED_HOME ?
// 				"Connected - home network" : "Connected - roaming");
// 		k_sem_give(&lte_connected);
//         break;
// 	case LTE_LC_EVT_RRC_UPDATE:
// 		LOG_INF("RRC mode: %s", evt->rrc_mode == LTE_LC_RRC_MODE_CONNECTED ?
// 				"Connected" : "Idle");
// 		break;
//      default:
//              break;
//      }
// }

// static int modem_configure(void)
// {
// 	int err;
// 	LOG_INF("Initializing modem library");

// 	err = nrf_modem_lib_init();
// 	if (err) {
// 		LOG_ERR("Failed to initialize the modem library, error: %d", err);
// 		return err;
// 	}

// 	LOG_INF("Connecting to LTE network");

// 	err = lte_lc_init_and_connect_async(lte_handler);
// 	if (err) {
// 		LOG_INF("Modem could not be configured, error: %d", err);
// 		return err;
// 	}

// 	k_sem_take(&lte_connected, K_FOREVER);
// 	LOG_INF("Connected to LTE network");
// 	dk_set_led_on(DK_LED2);

// 	return 0;
// }



// int main(void)
// {
// 	int ret;
// 	int err;
// 	uint32_t connect_attempt = 0;

// 	if (!device_is_ready(uart)){
// 		printk("UART device not ready\r\n");
// 		return 1 ;
// 	}

// 	if (dk_leds_init() != 0) {
// 		LOG_ERR("Failed to initialize the LED library");
// 	}

// 	err = modem_configure();
// 	if (err) {
// 		LOG_ERR("Failed to configure the modem");
// 		return 0;
// 	}


// 	err = client_init(&client);
// 	if (err) {
// 		LOG_ERR("Failed to initialize MQTT client: %d", err);
// 		return 0;
// 	}

// do_connect:
// 	if (connect_attempt++ > 0) {
// 		LOG_INF("Reconnecting in %d seconds...",
// 			CONFIG_MQTT_RECONNECT_DELAY_S);
// 		k_sleep(K_SECONDS(CONFIG_MQTT_RECONNECT_DELAY_S));
// 	}

// 	LOG_INF("Connection to broker using mqtt_connect");

	
// 	err = mqtt_connect(&client);
// 	if (err) {
// 		LOG_ERR("Error in mqtt_connect: %d", err);
// 		goto do_connect;
// 	}

// 	ret = uart_callback_set(uart, uart_cb, NULL);
// 	if (ret) {
// 		return 1;
// 	}


// 	ret = uart_rx_enable(uart ,rx_buf,sizeof rx_buf,RECEIVE_TIMEOUT);
// 	if (ret) {
// 		return 1;
// 	}
	

// 	err = fds_init(&client,&fds);
// 	if (err) {
// 		LOG_ERR("Error in fds_init: %d", err);
// 		return 0;
// 	}

// 	while (1) {

// 		printk("testing in while\n\r");

// 		if (flag1)
// 		{
// 			data_publish(&client, MQTT_QOS_1_AT_LEAST_ONCE, temp, sizeof(temp)-1);
// 			flag1 = 0;
// 			// printk("data_sent?\n\r");
// 			printk("Data: %s\n\r",temp);
// 			for(size_t i = 0; i<RECEIVE_BUFF_SIZE; i++)
// 			{
// 				temp[i] = 0; 
// 			}
// 		}

// 		err = poll(&fds, 1, mqtt_keepalive_time_left(&client));
// 		if (err < 0) {
// 			LOG_ERR("Error in poll(): %d", errno);
// 			break;
// 		}

// 		err = mqtt_live(&client);
// 		if ((err != 0) && (err != -EAGAIN)) {
// 			LOG_ERR("Error in mqtt_live: %d", err);
// 			break;
// 		}

// 		if ((fds.revents & POLLIN) == POLLIN) {
// 			err = mqtt_input(&client);
// 			if (err != 0) {
// 				LOG_ERR("Error in mqtt_input: %d", err);
// 				break;
// 			}
// 		}

// 		if ((fds.revents & POLLERR) == POLLERR) {
// 			LOG_ERR("POLLERR");
// 			break;
// 		}

// 		if ((fds.revents & POLLNVAL) == POLLNVAL) {
// 			LOG_ERR("POLLNVAL");
// 			break;
// 		}
// 	}

// 	LOG_INF("Disconnecting MQTT client");

// 	err = mqtt_disconnect(&client);
// 	if (err) {
// 		LOG_ERR("Could not disconnect MQTT client: %d", err);
// 	}
// 	goto do_connect;

// 	/* This is never reached */
// 	return 0;
// }



//----with workqueue-----------




#include <stdio.h>
#include <string.h>
#include <zephyr/kernel.h>
#include <zephyr/net/socket.h>
#include <zephyr/logging/log.h>
#include <dk_buttons_and_leds.h>
#include <modem/nrf_modem_lib.h>
#include <modem/lte_lc.h>
#include <zephyr/net/mqtt.h>
#include "mqtt_connection.h"
#include <zephyr/device.h>
#include <zephyr/devicetree.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/sys/printk.h>
#include <zephyr/logging/log.h>
#include <zephyr/drivers/uart.h>

// UART2 
#define SLEEP_TIME_MS   1000
#define RECEIVE_BUFF_SIZE 70
#define RECEIVE_TIMEOUT 1000  // usec  around 10 usec for each bit that is transmitted 


// change it to uart0 in case of Fanstel module

const struct device *uart= DEVICE_DT_GET(DT_NODELABEL(uart0));
static uint8_t rx_buf[RECEIVE_BUFF_SIZE] = {0};

static struct mqtt_client client;
static struct pollfd fds;
static K_SEM_DEFINE(lte_connected, 0, 1);

LOG_MODULE_REGISTER(LTE, LOG_LEVEL_DBG);


//******************************

#define SERIAL_Q_SIZE 5

static struct work_data{    
    struct k_work work;    
    char data[70]; 
    char data_len;						// should not be char for 1k data ?
}w_data[SERIAL_Q_SIZE];  

//******************************

static void uart_cb(const struct device *dev, struct uart_event *evt, void *user_data)
{
	static int serial_in_count;
	switch (evt->type) {

	case UART_RX_RDY:

		//printk("Checking UART triggering\n\r");
		// printk("D_len: %d\n\r",evt->data.rx.len); 										// for debugging 
		// memcpy(temp, &evt->data.rx.buf[evt->data.rx.offset], 70); 
		memcpy(&w_data[serial_in_count].data, &evt->data.rx.buf[evt->data.rx.offset], 70);
		k_work_submit(&w_data[serial_in_count].work);

		if (serial_in_count < SERIAL_Q_SIZE-1) {
			serial_in_count++;
		}
		else{
            serial_in_count=0;
        }

		break;



	case UART_RX_DISABLED:

		uart_rx_enable(dev ,rx_buf,sizeof rx_buf,RECEIVE_TIMEOUT);
		break;
		
	default:
		break;
	}

}



static void lte_handler(const struct lte_lc_evt *const evt)
{
     switch (evt->type) {
     case LTE_LC_EVT_NW_REG_STATUS:
        if ((evt->nw_reg_status != LTE_LC_NW_REG_REGISTERED_HOME) &&
            (evt->nw_reg_status != LTE_LC_NW_REG_REGISTERED_ROAMING)) {
            break;
        }
		LOG_INF("Network registration status: %s",
				evt->nw_reg_status == LTE_LC_NW_REG_REGISTERED_HOME ?
				"Connected - home network" : "Connected - roaming");
		k_sem_give(&lte_connected);
        break;
	case LTE_LC_EVT_RRC_UPDATE:
		LOG_INF("RRC mode: %s", evt->rrc_mode == LTE_LC_RRC_MODE_CONNECTED ?
				"Connected" : "Idle");
		break;
     default:
             break;
     }
}

static int modem_configure(void)
{
	int err;
	LOG_INF("Initializing modem library");

	err = nrf_modem_lib_init();
	if (err) {
		LOG_ERR("Failed to initialize the modem library, error: %d", err);
		return err;
	}

	LOG_INF("Connecting to LTE network");

	err = lte_lc_init_and_connect_async(lte_handler);
	if (err) {
		LOG_INF("Modem could not be configured, error: %d", err);
		return err;
	}

	k_sem_take(&lte_connected, K_FOREVER);
	LOG_INF("Connected to LTE network");
	dk_set_led_on(DK_LED2);

	return 0;
}



void pub_uart_mqtt(struct k_work *item)
{
    struct work_data *wrk_data = CONTAINER_OF(item, struct work_data, work);
    //printk("Data: %s\n", wrk_data->data);
    printk("Length of data:%d\n",wrk_data->data_len);
    data_publish(&client, MQTT_QOS_1_AT_LEAST_ONCE, wrk_data->data, 70);
		
}


int main(void)
{
	int ret;
	int err;
	uint32_t connect_attempt = 0;

	if (!device_is_ready(uart)){
		printk("UART device not ready\r\n");
		return 1 ;
	}

	if (dk_leds_init() != 0) {
		LOG_ERR("Failed to initialize the LED library");
	}

	err = modem_configure();
	if (err) {
		LOG_ERR("Failed to configure the modem");
		return 0;
	}


	err = client_init(&client);
	if (err) {
		LOG_ERR("Failed to initialize MQTT client: %d", err);
		return 0;
	}

do_connect:
	if (connect_attempt++ > 0) {
		LOG_INF("Reconnecting in %d seconds...",
			CONFIG_MQTT_RECONNECT_DELAY_S);
		k_sleep(K_SECONDS(CONFIG_MQTT_RECONNECT_DELAY_S));
	}

	LOG_INF("Connection to broker using mqtt_connect");

	
	err = mqtt_connect(&client);
	if (err) {
		LOG_ERR("Error in mqtt_connect: %d", err);
		goto do_connect;
	}


	for(int i=0; i < SERIAL_Q_SIZE; i++){
		k_work_init(&w_data[i].work, pub_uart_mqtt);
	}
	

	ret = uart_callback_set(uart, uart_cb, NULL);
	if (ret) {
		return 1;
	}


	ret = uart_rx_enable(uart ,rx_buf,sizeof rx_buf,RECEIVE_TIMEOUT);
	if (ret) {
		return 1;
	}

	
 
	err = fds_init(&client,&fds);
	if (err) {
		LOG_ERR("Error in fds_init: %d", err);
		return 0;
	}

	while (1) {

		err = poll(&fds, 1, mqtt_keepalive_time_left(&client));
		if (err < 0) {
			LOG_ERR("Error in poll(): %d", errno);
			break;
		}

		err = mqtt_live(&client);
		if ((err != 0) && (err != -EAGAIN)) {
			LOG_ERR("Error in mqtt_live: %d", err);
			break;
		}

		if ((fds.revents & POLLIN) == POLLIN) {
			err = mqtt_input(&client);
			if (err != 0) {
				LOG_ERR("Error in mqtt_input: %d", err);
				break;
			}
		}

		if ((fds.revents & POLLERR) == POLLERR) {
			LOG_ERR("POLLERR");
			break;
		}

		if ((fds.revents & POLLNVAL) == POLLNVAL) {
			LOG_ERR("POLLNVAL");
			break;
		}
	}

	LOG_INF("Disconnecting MQTT client");

	err = mqtt_disconnect(&client);
	if (err) {
		LOG_ERR("Could not disconnect MQTT client: %d", err);
	}
	goto do_connect;

	/* This is never reached */
	return 0;
}









